------------------------------
# V1.6.0 to V1.7.0
------------------------------

## Improved/Changed Features:

* [BO] : [#1524] Updated The hotel and room type filters on the advance price rules listing in the back-office.
* [BO] : [#1382] Added New columns to exported CSV using admin export in back office.
* [BO] : [#1337] Updated The flow of date from and date to for advance price rule create and update, and fixed price issue occurring during booking creation in back office.
* [BO] : [#1469] Fixed Added missing validation in the back-office.
* [BO] : [#1421] Fixed Translation issues in the back office
* [BO] : [#1375] Fixed Refund can be enabled in Hotel even if it is Disabled from Refund Rules page Globally

* [FO] : [#1324] Fixed undefined index when a product in cart is neither a booking product nor service product in front-office

* [CO] : [#1492] Added new configuration for the dimension unit for the bed types in the back-office.
* [CO] : [#1488] Updated the flow for feature prices, added option to add multiple restrictions in a single feature price for a room type in back-office.
* [CO] : [#1464] Updated Upgrade for PHP version 8.1 to 8.4 and MYSql 8 compatibility
* [CO] : [#1412] Added New option to add bed types for a room type in back office.
* [CO] : [#1399] Added Standard product flow in QloApps
* [CO] : [#1346] Added Feature to create Advanced price rules for multiple room types at once in the back office.
* [CO] : [#1355] Updated The flow for the max order date and min booking offset.
* [CO] : [#1528] Updated The Google Maps API endpoints for improved performance and compatibility for the front and back-office.
* [CO] : [#1505] Added Secured queries with type casting to prevent SQL injection and sanitized values against XSS.
* [CO] : [#1470] Optimized The tree creation process from the helper tree, added option to add prefix in hotel helper while generating the tree data.
* [CO] : [#1378] Optimized Functions and removed unnecessary object initialization to reduce overhead.
* [CO] : [#1357] Updated Date format in hotel booking demands and removed non required validation from validateCartBookings() function.
* [CO] : [#1356] Added New column 'planned checkout' in the hotel booking detail.
* [CO] : [#1347] Updated parameters in hook 'actionRoomReallocateAfter'.
* [CO] : [#1342] Added occupancy in the functions and their calls in the QloApps core.

------------------------------
# V1.5.0 to V1.6.0
------------------------------

## Improved/Changed Features:

* [CO] : [#720] Fixed issues in response of Availability & Rates search API for partial available rooms
* [BO] : [#725] Fixed Pre-populate form values after invalid form submission of hotel form at back office
* [BO] : [#727] Fixed refund Rules for multiple hotels for same cancellation days can not be created
* [BO] : [#729] Fixed Hotel permissions are not saved when a hotel is created
* [BO] : [#733] Fixed admin can not set refund amount to 0 when creating refund rules
* [BO] : [#742] Fixed unable to delete room types from cart if admin visits book now page just after booking creation and before order confirmation
* [BO] : [#751] Fixed Groups selection is removed for Advanced Price Rule when status is changed
* [BO] : [#753] Fixed All file types are available for selection when choosing images for hotel and room type
* [CO] : [#756] Fixed cancellation charge amount is incorrect if order currency is other than default currency
* [CO] : [#759] Updated function call corrected for room type price calculations
* [BO] : [#763] Fixed Hote Reservation System tab icon breaks randomly
* [BO] : [#770] Updated disable cart popup button on admin Book Now page if cart is empty
* [BO] : [#775] Added demo service products for categories Meals and Transfers.
* [FO] : [#781] Improved room search user experience at front office
* [BO] : [#784] Admin can add partial order payment when creating a new booking.
* [BO] : [#789]  Updated set default occupancy chosen on search results, room type detail and admin book now pages
* [BO] : [#790] Fixed rooms stats issue on admin Book Now page when adding or removing rooms from cart
* [BO] : [#798] Updated move navbar Customer Support contact settings to Hotel Reservation System > Settings > General Settings page
* [BO] : [#806] Fixed new cart getting created even if there are no active hotels for booking at back office Book Now page
* [BO] : [#807] Added Warning for maximum quantity of service products in Extra Services popup when creating or editing a booking at back office.
* [BO] : [#808] Updated move Week Days list in a new row on Advanced Price Rule form at back office
* [CO] : [#810] Updated Use datepicker plugin to format dates using $.datepicker.parseDate() wherever applicable
* [CO] : [#812] Added new hooks
* [BO] : [#815] : Updated added Rooms filter and added suggestions for Hotel and Room type filter inputs on admin orders list page
* [CO] : [#823] Updated text changes
* [BO] : [#824] Fixed allotment Type selection in partial available rooms in book now page
* [BO] : [#825] Fixed auto added services is not visible at back office add order and view order page
* [BO] : [#826] Updated filter by Places panel removed and added advanced filters and room type positioning on Manage Room Types page at back office
* [BO] : [#830] Added option to disable backdate order from superadmin and employees.
* [FO] : [#833] Added 'Show at front office' option to enable/disable booking from front office.
* [BO] : [#835] Updated make Customer Groups inaccessible if option Customer Groups is disabled on Advanced Parameters > Performance page
* [BO] : [#836] Fixed employee form language memorization (Administration > Employees) not working for some forms
* [FO] : [#839] Added error message for maximum occupancy in room occupancy dropdown.
* [BO] : [#840] Fixed calendar tooltips reappear on admin book now page after adding or removing rooms from cart
* [BO] : [#841] : Updated prevent room deletion and room status update to inactive when room has future booking
* [CO] : [#843] Fixed friendly URL for search results page can not be changed
* [BO] : [#854] Fixed errors shown on order detail page in back office when booked hotel is deleted
* [CO] : [#855] Fixed issues in getting(GET), creating(POST) and updating(PUT) hotel by hotel API
* [BO] : [#856] Fixed price conversion issues while changing currency in order detail page in back office
* [CO] : [#871] Updated tax of room type will be applied to auto add services having price added to room price
* [BO] : [#883] Added 'Save and stay' button on missing pages at back office.
* [BO] : [#884] Added Accurate page name display in "Visitors online" statistics.
* [CO] : [#885] Updated address country of demo customer 'pub@qloapps.com' changed to website default country
* [BO] : [#888] Updated default listing order of rooms on admin book now page to ascending order of room database ID.
* [BO] : [#889] Fixed new hotel category gets created instead of updating previous one on hotel name update at back office
* [BO] : [#890] Service products can now be assigned to a room type from room type edit page at back office.
* [CO] : [#892] Updated use different prefixes for demo room numbers belonging to different room types
* [CO] : [#895] Fixed overbooking issues in QloApps and added new configurations for overbooking handling
* [BO] : [#901] Added upgrade/degrade of rooms while reallocation and also fixed reallocation and swapping issues.
* [BO] : [#907] Fixed room reallocation process on AdminHotelRoomsBooking controller caused by space in the name of the room.
* [CO] : [#908] Improved Order Status changes, Refund issues resolved and order and cancellation process improved
* [CO] : [#909] Fixed missing translation from the templates of the modules.
* [BO] : [#913] Fixed added auto add services to the rooms added to the order by admin on edit order from the admin panel
* [BO] : [#916] Fixed auto added services price not showing in cart summary in admin book now page
* [BO] : [#923] Fixed service product price and quantity was added incorrectly in order on edit/update
* [FO] : [#924] Fixed incorrect room price and final price when admin remove service product or update room price from admin end and proceed for payment at front office
* [BO] : [#925] Fixed multiple Advance Price Rule can be created with same conditions
* [CO] : [#928] Added new hooks
* [BO] : [#929] Fixed AdminOrdersRefundRequestsController showing exception to all employees except the super admin.
* [CO] : [#931] Fixed js issue due to map if Google Maps API key is set and hotel location is not set
* [BO] : [#936] Fixed date selection corrections at different places in admin controllers.
* [BO] : [#939] Updated optimized search results in the admin search page.
* [BO] : [#941] Admin can add custom prices for facilities and services while editing order.
* [CO] : [#951] Added values for columns 'price_calculation_method' and 'price_addition_type' for demo service products.
* [BO] : [#958] Fixed admin was able to update the booking dates of a room in an order to the disabled dates of that room.
* [BO] : [#962] Added new categories in demo data.
* [CO] : [#964] Fixed room type categories were not updated when hotel name or location is updated
* [CO] : [#972] Improved Algo for response data and format
* [BO] : [#982] Fixed advance price rule created during booking are visible in room type price tab
* [BO] : [#1004] Fixed issues in the process of booking creation from back office
* [BO] : [#1007] Fixed maximum occupancy, length of stay and specific prices are not duplicating correctly while duplicating a room type.
* [BO] : [#1012] Fixed creation of two separate HotelAdvancedPayment objects for a newly created room type from two separate tabs
* [BO] : [#1016] Added display global max order date and global preparation time in the restriction tab in manage hotels.
* [BO] : [#1019] Fixed empty copywrite year range in the footer incase the admin does not provide the website launch year.
* [CO] : [#1027] Fixed cart rule does not show under available coupons when cart rule is created from refund request
* [BO] : [#1029] Fixed hotel configuration options in settings only visible in default language
* [BO] : [#1031] Updated tab wise permission restriction on the hotel feature delete process.
* [BO] : [#1033] Fixed filter issue on Admin refund request page
* [BO] : [#1046] Fixed getting errors in the back office if the id in the URL is updated manually to an invalid one.
* [BO] : [#1049] Fixed warnings for invalid IMAP configuration after saving the default message in the contact in the back office.
* [CO] : [#1054] Fixed when Order status set as cancelled the rooms are not set is_cancelled=1 in the htl_booking_detail table
* [CO] : [#1062] Updated htaccess files comptible with apache 2.2 and 2.4
* [BO] : [#1070] Updated validations for Hotel address when add a new hotel
* [CO] : [#1084] The google maps will now display the map icon for the hotel locations.
* [BO] : [#1094] Added Admin can set voucher expiry along with voucher when managing refund request.
* [CO] : [#1097] Fixed issues in Refund management flow and Improved Order cancellation flow
* [CO] : [#1105] Added option for modules to manipulate KPI data.
* [BO] : [#1114] Fixed admin cannot create different Advance price rule for different group for same date ranges
* [BO] : [#1120] Fixed incorrect prices show in admin refund request controller
* [CO] : [#1121] Added new hooks
* [BO] : [#1125] Fixed invoice data is not correct when multiple invoices created in an order from back-office
* [BO] : [#1129] Fixed Dashboard issues on different sections
* [FO] : [#1133] Updated original price will now be displayed with discounted amount.
* [CO] : [#1136] Fixed cancelled room service is visible when same room is added again in order
* [CO] : [#1140] Updated the hero image and its upload process.
* [CO] : [#1153] Fixed partial cart rule not creating when using multiple coupons in a single cart
* [CO] : [#1156] Updated the demo data added to the database for the QloApps on installation.
* [CO] : [#1161] Updated id_address_delivery is now set as 0 by default
* [CO] : [#1162] Fixed hotel permission are not being created for new hotels.
* [CO] : [#1170] Added date wise breakdown in Availability and rates search API
* [CO] : [#1174] Updated helper tree | Created a new helper tree class for generating tree
* [CO] : [#1175] Fixed issues in the Webservices.
* [BO] : [#1176] Updated the disabled dates interface, add and update process.
* [BO] : [#1185] Updated the tab menu list of the hotel reservation system in the back office.
* [BO] : [#1187] Added feature in tree to select all children node when parent node is selected and fixed some text issue
* [BO] : [#1188] Updated hotel features assigning process in the back office.
* [CO] : [#1191] Added webservice for bookings management.
* [CO] : [#1194] Updated optimized dataForFrontSearch function
* [CO] : [#1195] Added process for smarty template overriding.
* [CO] : [#1198] Optimized Hotel Room Type Availability and rates search webservice
* [CO] : [#1200] Updated price Rounding process improved in entire QloApps system
* [CO] : [#1202] Fixed service not visible in booking when service is deleted from catalog after order
* [CO] : [#1203] Fixed invalid auto-added service prices when multiple rooms are added in cart or service is disabled or removed from catalog.
* [CO] : [#1217] Added changes in core algo for managing booking for hourly basis
* [BO] : [#1240] Fixed the design issues with the pop up in the search form in Book Now page in back-office.
* [FO] : [#1249] Fixed translation issues and removed slashes in the error message from cart validation process in the front-office.
* [CO] : [#1250] Fixed Categories for demo service products are not created correctly on installation.
* [BO] : [#1251] Fixed occupancy selection panel design issue in Backoffice book now page
* [BO] : [#1264] Added Seo fields in manage hotel controller in the back-office
* [CO] : [#1271] Added new hooks
* [FO] : [#1272] Fixed order confirmation and Guest tracking flow issues and order emails are improved
* [BO] : [#1284] Fixed getting fatal error on AdminHotelRoomsBookingController when an employee adds an invalid date in the search booking form in back-office.
* [BO] : [#1291] Updated validation for 'Consider guest as child below age' in the back-office and removed child ages from occupancy fields in case 'Maximum children' for a room type is 0 from front-office.
* [FO] : [#1292] Fixed design issues on the order-opc page and growl notifications in RTL mode in the front-office.

------------------------------
# V1.4.3 to V1.5.0
------------------------------

## Improved/Changed Features:

* [CO] : [#650] Added: Feature per day price in extra services
* [FO] : [#651] Fix: imgaes index not defined for services on room type page in front office
* [BO] : [#607] Updated: Service products pop-up modal in admin order view page
* [FO] : [#649] Fix: Occupancy panel does not close when clicking on add to cart button
* [CO] : [#622] Added: Primary hotel in QloApps for tax calculation of service products
* [BO] : [#542] Resolved: advance price rules validation issue
* [BO] : [#644] Change refund rule text from 'Days before cancellation' to 'Days before check-in' at back office
* [CO] : [#612] Resolved: hotel tagline and short description wrong format
* [BO] : [#554] Resolved: room status update issue from active to inactive.
* [CO] : [#621] Resolved: Catalog discount is not visible when auto add service is attached to room type
* [BO] : [#611] Updated: added complete booking info in admin booking carts tab
* [BO] : [#518] Fixed: User input in location field in search panel get replaced by hotel location
* [BO] : [#589] Add cancellation policy section on admin order view page
* [BO] : [#632] Update disable dates selection for a room at back office
* [BO] : [#639] Update refund request view page at back office
* [FO] : [#605] Resolved: Service producs all images not visible in front office
* [CO] : [#584] Resolve: Inactive auto add service price still gets added to room price
* [CO] : [#583] Resolved: Unable to add room in cart from front and backoffice
* [BO] : [#582] Removed selected extra services list from current cart in backoffice book now summary
* [BO] : [#579] Resolved: Exception on admin book now page after cleaning cart data
* [CO] : [#574] Fix:  Services price not including in cancelation charges.
* [BO] : [#544] Resolved: bad sql query issue when assigning features to the hotel
* [BO] : [#625] Fixed: book now page calender does not show searched date month
* [FO] : [#608] Fix: Unable to remove disabled services from cart
* [FO] : [#615] Resolved: Order restrict error is displayed multiple time on checkout page
* [CO] : [#616] Resolved: Mulitple hotel cover image created when uploading multiple images
* [BO] : [#599] Fix js errors on admin book now page
* [BO] : [#597] Fix filter issues on Assign Hotel Features page at back office
* [CO] : [#595] Text changes
* [BO] : [#571] Remove Order Restrict link from Hotel Reservation System > Settings page
* [CO] : [#559] Change link in credit slip email
* [CO] : [#549] Resolved: issue on free order and room reallocation
* [CO] : [#546] Replaced: child with children in occupancy text
* [CO] : [#538] Added: Feature service products
* [CO] : [#526] Update refund option and orders state mangement
* [CO] : [#527] Fix CLI install issues
* [BO] : [#531] Allow admin to upload check-in documents
* [CO] : [#528] licenses updated
* [CO] : [#521] Updated occupancy dropdown
* [BO] : [#522] Updated: Book now page calender view
* [CO] : [#514] Resolve: Occupancy wise search feature issues
* [CO] : [#475] Added Feature: Occupancy wise search and booking
* [CO] : [#500] Improve order refund flow
* [BO] : [#473] Fix database exception issue on Book Now page at back office when multiple QloApps installations are present on the same domain
* [BO] : [#495] Added: missing re-allocation pop-up and improved design in book now page
* [BO] : [#456] Allow admin to add new links on Hotel Reservation System > Settings page and removed shortcut links of "Our Rooms" and "Testimonial" modules
* [BO] : [#464] Implement Additional Facilities tab in AdminProductsController instead of using hotelreservationsystem module hook
* [CO] : [#476] Use object methods save() and delete() for classes HotelCartBookingData and HotelBookingDetail
* [BO] : [#478] Update admin book now page design | added fullcalender
* [CO] : [#468] Update image generation method for hotel and default modules
* [CO] : [#479] New Feature: Preparation time for bookings
* [CO] : [#458] Replace module 'productcomments' with 'qlohotelreview'
* [BO] : [#451] Improve statistics at back office
* [BO] : [#460] Remove characters limit of 128 for hotel fields 'map_formated_address' and 'map_input_text'
* [BO] : [#455] Fix Book Now page at back office
* [CO] : [#436] Text changes
* [FO] : [#403] Add maps to search results and room type detail pages
* [BO] : [#413] Fix date formats at back office
* [CO] : [#435] Added feature: minimum and maximum length of stay restriction for room types
* [BO] : [#429] Add price modification for new orders at back office
* [CO] : [#420] Remove unused code and data from module hotelreservationsystem
* [FO] : [#419] Fix hero image cache issue
* [CO] : [#418] Add hooks 'displayAdminAddHotelFormTab' and 'displayAdminAddHotelFormTabContent' in Manage Hotel tab of Back-office
* [FO] : [#417] Resolved address issue on contact page for list and map
* [CO] : [#415] Removed qlo_mod_list.xml
* [BO] : [#412] Resolve dashboard design issues
* [CO] : [#402] Change module category for graphnvd3 and hotelreservationsystem modules
* [CO] : [#401] Remove unused modules
* [FO] : [#410] Add hotel images under room information on room type detail page
* [BO] : [#409] Change Feature Price name to Advanced Price Rule
* [CO] : [#416] Resolved wrong address while creating new booking
* [CO] : [#394] Fix hotel city access method as introduced in tax flow changes
* [BO] : [#391] Updated dashboard structure | Fixed dashboard widget
* [CO] : [#371] Updated tax flow, Taxes are now calculated based on hotel address
* [BO] : [#382] Resolve undefined index issue on Order Restrict update form
* [CO] : [#381] Change demo city name from DefCity to Demo City
* [BO] : [#376] Remove global price option when not needed from additional facilities…
* [CO] : [#363] Text changes
* [CO] : [#356] Moved hotelreservationsystem "actionvalidateorder" to core function "validateorder"
* [CO] : [#366] Updated core upgrade files and modules upgrade files
* [BO] : [#357] Remove module config links from Hotel Reservation System > Settings page
* [BO] : [#351] Improve hotel address selection on map using marker at back office
* [BO] : [#345] Improve room type duplication feature
* [CO] : [#338] Replace booking type integer values with class constants
* [CO] : [#334] Remove install.sql files from modules
* [FO] : [#619] Show service cost separately from room cost on checkout page
* [CO] : [#636] Resolved: refund request payment calculation
* [BO] : [#653] Updated: Additional facilities panel in admin room type page
* [CO] : [#490] Added "Hotel Availability and Rates search API"  to QloApps
* [CO] : [#650] Added: Feature per day price in extra services
* [FO] : [#651] Fix: imgaes index not defined for services on room type page in front office
* [FO] : [#658] Replaced: child with children in occupancy text front-office
* [FO] : [#668] Fixed: Error on search result page when updating invalid occupancy in URL
* [CO] : [#669] Updated: text translations call variable assigned to javascript
* [BO] : [#670] Updated: Admin room type services and facilities panel text issues and undefined index issue
* [CO] : [#684] Fix PHP warning issue in catalog mode
* [CO] : [#693] Fix: hotel not getting added in hotel profile access table
* [BO] : [#694] Resolve: errors while adding new hotel
* [BO] : [#695] Fixed: dashboard  graphs errors when data set is empty
* [BO] : [#696] Updated: Manage room type default configuration and advance payment form options
* [FO] : [#699] Fix: service product quantity getting updated incorrectly from order OPC page
* [FO] : [#700] Fix: quantity does not change on room type page booking form
* [CO] : [#704] Updated: Data in admin refund request, corrected data in rooms refund detail table.


-------------------------
# V1.4.2 to V1.4.3
-------------------------

## Improved/changed features:

[*] BO : [#253] Using room status as constants instead in values, removed HotelOrderStatus class
[*] BO : [#270] Using room availability status as constants instead in values, removed HotelRoomStatus class
[*] CO : [#244] Changed Tools::jsonEncode to json_encode
[*] CO : [#283] Invalid value inserted in 'special_days' field in htl_room_type_feature_pricing table through API
[*] CO : [#284] Resolved: No validation for the fields in 'hotel_refund_rules' API for add and update.
[*] CO : [#289] Validations added to the fields of "bookings" API for POST / PUT API requests
[*] CO : [#274, #274] Text changes
[*] CO : [#290] Using $this->_path for including css and js | Moved plugins to core js folder


## Bug/Issues Resolved:

[-] BO : [#259] fixed room reallocation availability list for temporary unavailable rooms
[-] BO : [#256] Fixed Swap rooms leads to reservations duplications
[-] CO : [#252] Fixed getRoomBookingData function always return the first room for same room in order with different dates
[-] CO : [#291] Resolved: Wrong price return by advance payment functions in HotelAdvancedPayment class
[-] CO : [#294] Resolve order edit issues, Added hooks in order edit process
[-] CO : [#303] In ' Manage Hotel' Controller, validation added for 'check-out time must be before check in'





-------------------------
# V1.4.1 to V1.4.2
-------------------------

## Added Features:

[+] CO : [#198] Multiple hooks are added in the different QloApps core files

## Improved/changed features:

[*] BO : [110, #111] Code Optimization
[*] BO : [#179] Added hotel column in room type feature pricing list
[*] BO : [#204, #196, #182] Text Changes
[*] BO : [#193] Removed Payment Modules setting from admin Hotel Reservation System -> Settings
[*] BO : [#206] Removed Other Modules setting from admin Hotel Reservation System -> Settings

[*] CO : [#215] "hotelreservationsystem.php" code optimization in hook "actionValidateOrder"
[*] CO : [#221] dataforfrontsearch() function now calculate and provide "feature_price_diff" value in response
[*] CO : [#223] getHotelCartBookingData() : function multiplication optimized
[*] CO : [#225] HotelRoomTypeFeaturePricing.php optimized (Removed unused variables, removed static values assigned)

## Bug/Issues Resolved:

[-] FO : Fixed : [#169] Wrong price displayed when booking from 1 march to 30 march
[*] FO : [#215] "ajax-cart.js" add validation

[-] BO : Fixed : [#162] Additional facility price changes for room type after saving
[-] BO : Fixed : [#168] Room number not updating after room reallocation and swap
[-] BO : Fixed : [#173] Undefined varaible issue Manage Order Refund Request Controller
[-] BO : Fixed : [#211] Errors on cart rule page when add room type, which is not assigned to hotel, selected in room type condition
[-] BO : Fixed : [#229] Resolved undefined variable error in Manage Order Refund Request Controller



-------------------------
# V1.4.0 to V1.4.1
-------------------------

## Added Features:

[+] CO : Columns `active_refund` are added in 'htl_branch_info' table.
[+] CO : Columns `total_paid_amount`, `available_for_order`, `hotel_name`, `room_type_name`, `city`, `state`, `country`, `zipcode`, `phone`, `email`, `check_in_time`, `check_out_time`, `room_num`, `adult`, `children` in 'htl_booking_detail' table.
[+] CO : tables 'htl_room_type_feature_pricing_group', 'htl_branch_refund_rules', 'htl_order_refund_rules' added.
[+] CO : Class 'HotelBranchRefundRules' is added.
[+] CO : datatable library is addded to the module.
[+] CO : wk_refund_request.js, wk_refund_rule.js addded to the module.

[+] BO : Occupancy setting added in the Hotel General Setting Tab.
[+] BO : Feature Price Rule: Groups wise Condition in feature price rules is added.
[+] BO : Admin can enable/disable refund for the hotel.
[+] BO : Refund rules can be selected hotel wise.

## Improved/changed features:

[*] CO : All files license year is updated to 2020.
[*] CO : tables 'htl_customer_adv_payment', 'htl_customer_adv_product_payment', 'htl_order_refund_info', 'htl_order_refund_stages' are removed.
[*] CO : Classes 'HotelCustomerAdvancedPayment', 'HotelCustomerAdvancedProductPayment', 'HotelOrderRefundInfo', 'HotelOrderRefundStages' are removed.
[*] CO : All search block css and js are moved to "wkroomsearchblock" module.
[*] CO : Images link are now generated dynamically

[*] BO : In Admin Refund Rules controller name and description fields are added.
[*] BO : Admin Refund Request controller is improved and now will work as per new flow of refund process.
[*] BO : Create demo zipcode if zipcode is required and pattern not provided.

## Bug/Issues Resolved:
[-] CO : Resolved:: Feature price wrong calculation in currencies other than default currency in case of impact way percentage.


## Update Policy

- Database changed, Module need upload new file then UNINSTALL and re-installation.


-------------------------
# V1.3.0 to V1.4.0
-------------------------

## Added Features:

[+] CO : Table `htl_booking_demands_tax` added to the module for additional facility tax.
[+] CO : Table `htl_access` added to the module to manage hotel wise permission management.
[+] BO : Additional facility : Tax can be applied on additional facilities.
[+] BO : Additional facility : Per day price calculation option is added.[Price will be calculated on per day basis of the booking or for entire date range of the booking]
[+] BO : All controllers accesses are now manages according to the hotel wise permission management.

[+] CO : hookActionObjectProfileAddAfter, hookActionObjectProfileDeleteBefore are added to add and delete hotel accessed while adding or deleting any profile.


## Improved/changed features:

[+] CO : Table `htl_booking_demands` altered to the manage to additional facility tax.
[*] CO : getCartFormatedBookinInfoByIdCart(), getCartExtraDemands() functions improved for extra demands in HotelCartBookingData class.
[*] CO : add(), initAccess(), addHotelsAccessToProfile(), deleteProfileHotelsAccess(), getProfileAccessedHotels(), filterDataByHotelAccess() added in class HotelBranchInformation for managing hotel wise permission management.
[*] CO : delete() updated in class HotelBranchInformation to delete from htl_access for managing hotel wise permission management while deleting a hotel.
[*] CO : updateBookingOrderStatusByOrderId() updated in class HotelBookingDetail.

[*] BO : Only imported countries will be shown in the country dropdown while saving a hotel.

## Bug/Issues Resolved:

[-] CO : Resolved: Room type's Advance payment information is now saved while adding room types on the installation of the module. [As room type is unavailable for the advance payment]
getProductFeaturePricePlanByDateByPriority
[-] BO : Resolved: Hotel image file does not delete from the folder after hotel image deletion.


## Update Policy

- Database changed, Module need upload new file then UNINSTALL and re-installation.


-------------------------
# V1.2.2 to V1.3.0
-------------------------

## Added Features:

[+] CO : Additional Facility functionality is added.
[+] CO : `extra_demands` columnn added to the table `htl_cart_booking_data`.
[+] CO : Tables `htl_booking_demands`, `htl_room_type_global_demand`, `htl_room_type_global_demand_lang`, `htl_room_type_global_demand_advance_option`, `htl_room_type_global_demand_advance_option_lang`, `htl_room_type_demand_price`, `htl_room_type_demand` are added to the module to manage extra demand feature.

[+] BO : AdminRoomTypeGlobalDemand controller added to create and update extra demands.
[Hotel reservation system -> Settings -> Additional Demands]

[+] BO : "EXTRA DEMANDS" tab added while updating a room type.


## Improved/changed features:

[*] CO : mp-form-fields-flag.tpl name changed to htl-form-fields-flag.tpl
[*] BO : Tiny mce fields validations improved.
[*] BO : Feature price settings filters are improved.
[*] BO : Order Refund rules page filters are improved.
[*] BO : Order Refund Requests page filters are improved.
[*] BO : Book Now page search process is improved.
[*] BO : Google map key is now at General Settings -> GOOGLE MAP SETTING only removed from Preferences->General tab.

## Bug/Issues Resolved:

[-] BO : Zipcode in demo data is now dynamic for selected country while QloApps installation.


## Update Policy

- Database changed, Module need upload new file then UNINSTALL and re-installation.


-------------------------
# V1.2.1 to V1.2.2
-------------------------

## Improved/changed features:

[+] CO : Demo data insertion improved.
[+] CO : getHotelCartBookingData() improved as used many places in QloApps.

[+] CO : Call to HotelImage::validateImage() is deprecated.
[+] CO : Call to Hotelhelper::validImageExt() is deprecated.


[+] BO : Unused category deletion process added on hotel deletion. function deleteUnusedHotelCategories() added.
[+] BO : Hotel creation code improved.
[+] BO : Images validation improved.
[+] BO : Zipcode validation is improved as per selected country.


## Bug/Issues Resolved:

[-] CO : Zipcode in demo data is now dynamic for selected country while QloApps installation.



## Update Policy

- Mobule need only file update, can be updated only by UPLOADING new version on module


-------------------------
# V1.2.0 to V1.2.1
-------------------------

## Added Features:

[+] CO : Demo data will be now populated as per choice while Qloapps installation (populate data or not option).


## Improved/changed features:

[-] BO : Resolved :: view page of AdminHotelFeatures improved when no features exists.


## Bug/Issues Resolved:

[-] BO : Resolved :: "HTTP ERROR 500"  when clicking "Book Now" tab.



## Update Policy

- Mobule need only file update, can be updated only by UPLOADING new version on module


-------------------------
# V1.1.1 to V1.2.0
-------------------------

## Added Features:

[+] CO : index.php added/Updated in all folders
[+] CO : License.txt added.
[+] CO : License added in every file.
[+] CO : logo.gif file added.

[+] CO : Module is made multilang now.
[+] CO : 'htl_room_type_feature_pricing_lang' table added to make Feature Price rules controller multilang.
[+] CO : 'htl_features_lang' table added to make Manage Hotel Features controller multilang.
[+] CO : 'htl_branch_info_lang' table added to make 'Manage Hotels' controller multilang.

[+] CO : HotelHelper::getQloNativeModules() added for module list of Qloapps
[+] CO : HotelHelper::updateConfigurationLangKeys(), HotelHelper::updateLangTables() added for lang tables management when importing new language from localization

[+] BO : AdminAssignHotelFeatures controller added to Manage Hotel Features.
[+] BO : On contact us page contact header, contact content, global address are now dynamic. Enter values from AdminGeneralSettingsController.
[+] BO : Configuration to show/hide only one active hotel is added in location search panel in Hotel General Settings.

## Improved/changed features:

[+] CO : PREFIX_htl_image table changed for hotel cover image feature.
[+] CO : `id` is changed to `id_feature_price` in 'htl_room_type_feature_pricing_lang' table.
[+] CO : MultiLang fields removed from tables 'htl_room_type_feature_pricing_lang', 'htl_features_lang', 'htl_branch_info_lang' tables.

[+] BO : Seperate configuration panel is made for location search panel in Hotel General Settings.


## Bug/Issues Resolved:

[-] CO : Resolved :: hotelreservationsystem:: Hotel images not saved while saving hotel details.

[-] BO : Resolved :: hotelreservationsystem - $max_phone_digit is undefined issue resolved on hotel creation form.

[-] CO : Resolved :: hotelreservationsystem - Parent:: replaced with parent:: in classes/hotelHotelBranchInformation.php which was creating problems in installation.

[-] CO : Resolved :: hotelreservationsystem:: HotelBookingDetail.php : phone number sent as string '0987654321'from 0987654321. Giving error while installing Qloapps with php7.0.0 .

[-] BO : Resolved :: If current date is the last date then data to is change to the next date while Book now from admin.

## Update Policy

- Database changed, Module need upload new file then UNINSTALL and re-installation.